unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    RadioGroup1: TRadioGroup;
    lblFromX: TLabel;
    lblFromY: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Button2: TButton;
    Button3: TButton;
    cmbInitialSystem: TComboBox;
    Label11: TLabel;
    lblToX: TLabel;
    lblToY: TLabel;
    cmbInitialSystemDatum: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    cmbTargetSystem: TComboBox;
    Label12: TLabel;
    cmbTargetSystemDatum: TComboBox;
    Edit11: TEdit;
    Label13: TLabel;
    Label14: TLabel;
    Bevel1: TBevel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    edtInputFile: TEdit;
    edtOutputFile: TEdit;
    btnBrowseInput: TButton;
    btnBrowseOutput: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    rgrpDecimalSeparator: TRadioGroup;
    rgrpDelimiter: TRadioGroup;
    btnBatchConvert: TButton;
    Label18: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cmbInitialSystemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnBrowseInputClick(Sender: TObject);
    procedure btnBrowseOutputClick(Sender: TObject);
    procedure btnBatchConvertClick(Sender: TObject);
  private
    procedure SetControlStatus;
  public
    { Public declarations }
  end;

type
  TGeodeticSystem = (GS_GR87 = 0, GS_WGS84 = 1, GS_ED50_CYPRUS = 2,
    GS_ED50_GREECE = 3, GS_ED50_MEANEUROPE = 4, GS_GR_BESSEL = 5);
  TPCSystem = ( PC_GR87 = 0, PC_UTM_ZONE29 = 1, PC_UTM_ZONE30 = 2,
    PC_UTM_ZONE31 = 3, PC_UTM_ZONE32 = 4, PC_UTM_ZONE33 = 5, PC_UTM_ZONE34 = 6,
    PC_UTM_ZONE35 = 7, PC_UTM_ZONE36 = 8, PC_UTM_ZONE37 = 9,
    PC_ED50_CYPRUS_ZONE6 = 10, PC_ED50_GREECE_ZONE4 = 11,
    PC_ED50_GREECE_ZONE5 = 12, PC_ED50_MEANEUROPE_ZONE0 =13,
    PC_ED50_MEANEUROPE_ZONE1 =14, PC_ED50_MEANEUROPE_ZONE2 =15,
    PC_ED50_MEANEUROPE_ZONE3 =16, PC_ED50_MEANEUROPE_ZONE4 =17,
    PC_ED50_MEANEUROPE_ZONE5 =18, PC_ED50_MEANEUROPE_ZONE6 =19,
  	PC_GR_HATT_ATHINA_CHALKIS = 20,	PC_GR_HATT_ATHINA_LAVRION = 21,
  	PC_GR_HATT_AEGINA = 22,	PC_GR_HATT_NEA_PSARA = 23,
	  PC_GR_HATT_THESSALONIKI = 24,	PC_GR_HATT_GIANNITSA = 25,
  	PC_GR_UTM3_WEST = 26,	PC_GR_UTM3_CENTRAL = 27,
	  PC_GR_UTM3_EAST = 28
);

function project_philambda_to_xy(phi, lambda: Real; var x, y, gamma: Real;
  pcsystem: Integer): Integer; stdcall; external 'icoordstrans.dll';

function project_xy_to_philambda(x, y: Real; var phi, lambda, gamma: Real;
  pcsystem: Integer): Integer; stdcall; external 'icoordstrans.dll';

function displace_geodetic_system(phi, lambda: Real;
  var resulting_phi, resulting_lambda: Real;
    source, dest: Integer): Integer; stdcall; external 'icoordstrans.dll';

function convert_xy(x1, y1: Real; var x2, y2, gamma: Real; source, dest:
  Integer):Integer ; stdcall; external 'icoordstrans.dll';

function GetGeodeticSystem(APCSystem: TPCSystem): TGeodeticSystem;

var
  Form1: TForm1;

implementation

uses Math, istrutils;

{$R *.dfm}

function GetGeodeticSystem(APCSystem: TPCSystem): TGeodeticSystem;
begin
  case Ord(APCSystem) of
    0: Result := GS_GR87;
    1..9: Result := GS_WGS84;
    10: Result := GS_ED50_CYPRUS;
    11, 12: Result := GS_ED50_GREECE;
    13..19: Result := GS_ED50_MEANEUROPE;
    20..28: Result := GS_GR_BESSEL;
  else
    Assert(False);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  in_a, in_b, out_a, out_b, gamma, xt, yt: Real;
  errno: Integer;
  AGSystem, AGSystem2: TGeodeticSystem;
begin
  gamma := 0;
  in_a := StrToFloat(Edit1.Text);
  in_b := StrToFloat(Edit2.Text);
  if RadioGroup1.ItemIndex in [1,3] then
  begin
    in_a := in_a*Pi/180;
    in_b := in_b*Pi/180;
  end;
  errno := 0;
  AGSystem := GetGeodeticSystem(TPCSystem(cmbInitialSystem.ItemIndex));
  AGSystem2 := GetGeodeticSystem(TPCSystem(cmbTargetSystem.ItemIndex));  
  case RadioGroup1.ItemIndex of
    0: begin
      errno := project_xy_to_philambda(in_a, in_b, xt, yt, gamma, cmbInitialSystem.ItemIndex);
      errno := displace_geodetic_system(xt, yt, out_a, out_b,
        ord(AGSystem), ord(AGSystem2));
    end;
    1: begin
      errno := displace_geodetic_system(in_a, in_b, xt, yt,
        ord(AGSystem), ord(AGSystem2));
      errno := project_philambda_to_xy(xt, yt, out_a, out_b, gamma,
        cmbTargetSystem.ItemIndex);
    end;
    2: errno := convert_xy(in_a, in_b, out_a, out_b, gamma,
      cmbInitialSystem.ItemIndex, cmbTargetSystem.ItemIndex);
    3: errno := displace_geodetic_system(in_a, in_b, out_a, out_b, Ord(AGSystem),
      Ord(AGSystem2));
  else
    Assert(False);
  end;
  if errno<>0 then raise Exception.Create('Math error');
  if RadioGroup1.ItemIndex in [0,3] then
  begin
    out_a := out_a*180/Pi;
    out_b := out_b*180/Pi;
  end;
  Edit3.Text := FloatToStr(out_a);
  Edit4.Text := FloatToStr(out_b);
  Edit11.Text := FloatToStr(gamma*180*60/Pi);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit1.Text := FloatToStr(StrToFloat(Edit5.Text)+
    StrToFloat(Edit6.Text)/60 + StrToFloat(Edit7.Text)/3600);
  Edit2.Text := FloatToStr(StrToFloat(Edit8.Text)+
    StrToFloat(Edit9.Text)/60 + StrToFloat(Edit10.Text)/3600);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  aphi, alambda: Real;
begin
  aphi := StrToFloat(Edit3.Text);
  alambda := StrToFloat(Edit4.Text);
  Edit5.Text := IntToStr(Trunc(aphi));
  Edit8.Text := IntToStr(Trunc(alambda));
  aphi := (aphi - Trunc(aphi))*60;
  alambda := (alambda - Trunc(alambda))*60;
  Edit6.Text := IntToStr(Trunc(aphi));
  Edit9.Text := IntToStr(Trunc(alambda));
  aphi := (aphi - Trunc(aphi))*60;
  alambda := (alambda - Trunc(alambda))*60;
  Edit7.Text := FormatFloat('0.000', aphi);
  Edit10.Text := FormatFloat('0.000', alambda);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  SetControlStatus;
end;

procedure TForm1.SetControlStatus;
begin
  case RadioGroup1.ItemIndex of
    0:
    begin
      lblFromX.Caption := 'X (m)';
      lblFromY.Caption := 'Y (m)';
      lblToX.Caption := 'phi ()';
      lblToY.Caption := 'lambda ()';
    end;
    1:
    begin
      lblFromX.Caption := 'phi ()';
      lblFromY.Caption := 'lambda ()';
      lblToX.Caption := 'X (m)';
      lblToY.Caption := 'Y (m)';
    end;
    2:
    begin
      lblFromX.Caption := 'X (m)';
      lblFromY.Caption := 'Y (m)';
      lblToX.Caption := 'X (m)';
      lblToY.Caption := 'Y (m)';
    end;
    3:
    begin
      lblFromX.Caption := 'X (m)';
      lblFromY.Caption := 'Y (m)';
      lblToX.Caption := 'phi ()';
      lblToY.Caption := 'lambda ()';
    end;
    4:
    begin
      lblFromX.Caption := 'phi ()';
      lblFromY.Caption := 'lambda ()';
      lblToX.Caption := 'phi ()';
      lblToY.Caption := 'lambda ()';
    end;
  end;
  cmbInitialSystemDatum.ItemIndex :=
    Ord(GetGeodeticSystem(TPCSystem(cmbInitialSystem.ItemIndex)));
  cmbTargetSystemDatum.ItemIndex :=
    Ord(GetGeodeticSystem(TPCSystem(cmbTargetSystem.ItemIndex)));
end;

procedure TForm1.cmbInitialSystemClick(Sender: TObject);
begin
  SetControlStatus;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  rgrpDecimalSeparator.Items[0] :=
    'System defined ('+SysUtils.DecimalSeparator+')';
end;

procedure TForm1.btnBrowseInputClick(Sender: TObject);
begin
  with OpenDialog do
    if Execute then
      edtInputFile.Text := FileName;
end;

procedure TForm1.btnBrowseOutputClick(Sender: TObject);
begin
  with SaveDialog do
    if Execute then
      edtOutputFile.Text := FileName;
end;

procedure TForm1.btnBatchConvertClick(Sender: TObject);
var
  SavedDecimalSeparetor, Delimiter: Char;
  InputStringList, OutputStringList: TStringList;
  ACursor: TCursor;
  i: Integer;
begin
  SavedDecimalSeparetor := SysUtils.DecimalSeparator;
  ACursor := Screen.Cursor;
  case rgrpDecimalSeparator.ItemIndex of
    0: SysUtils.DecimalSeparator := SavedDecimalSeparetor;
    1: SysUtils.DecimalSeparator := '.';
    2: SysUtils.DecimalSeparator := ',';
  else
    Assert(False);
  end;
  case rgrpDelimiter.ItemIndex of
    0: Delimiter := ',';
    1: Delimiter := ';';
    2: Delimiter := ' ';
    3: Delimiter := #09;
  else
    Assert(False);
  end;
  InputStringList := nil;
  OutputStringList := nil;
  try
    Screen.Cursor := crHourGlass;
    InputStringList := TStringList.Create;
    OutputStringList := TStringList.Create;
    InputStringList.LoadFromFile(edtInputFile.Text);
    for i := 0 to InputStringList.Count-1 do
    begin
      Edit1.Text := TrimAllSpaces(DelimitedStringItem(InputStringList[i], 1, Delimiter));
      Edit2.Text := TrimAllSpaces(DelimitedStringItem(InputStringList[i], 2, Delimiter));
      Application.ProcessMessages;
      Button1.Click;
      Application.ProcessMessages;
      OutputStringList.Add(Edit3.Text+Delimiter+Edit4.Text)
    end;
    OutputStringList.SaveToFile(edtOutputFile.Text);
  finally
    SysUtils.DecimalSeparator := SavedDecimalSeparetor;
    InputStringList.Free;
    OutputStringList.Free;
    Screen.Cursor := ACursor;
  end;
end;

end.
